//*****************************************************************************
// File Name            : spi_ap.v
//-----------------------------------------------------------------------------
// Function             : spi sample top module
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2010/10/27
//*****************************************************************************
module spi_ap ( 
 clk, rstb, led_0,
 sclk,ss0,ss1,ss2,ss3,mosi,miso,
 txd,rxd
);
  input clk;
  input rstb;  
  output led_0;
  output sclk;
  output ss0;
  output ss1;
  output ss2;
  output ss3;
  output mosi;
  input miso;
  output txd;   //serial tx data    
  input  rxd;   //serial rx data
  wire [1:0]dev_sel; //foCXI
  wire start;
  wire [4:0] clk_end;
  wire busy;   
  wire [31:0]wr_data; 
  wire [31:0]rd_data; 
  wire rd_data_en;
  wire ss0_tmp;
  wire ss1_tmp;
  wire ss2_tmp;
  wire ss3_tmp;

  wire [7:0] tx_fifo_data;    //tx fifo data 8bit
  wire       tx_fifo_data_en; //tx fifo data enable 
  wire       tx_fifo_ren;     //tx fifo read enable
  wire [7:0] tx_data;        //tx data 8bit
  wire       tx_data_en;      //tx data enable 
  wire       tx_busy;         //tx busy

//SPIC^[tF[X̃CX^X   
spi_m_if spi_m_if(   
  .clk(   clk),
  .rstb(  rstb),
  .sclk(  sclk),
  .ss0(    ss0_tmp),
  .ss1(    ss1_tmp),
  .ss2(    ss2_tmp),
  .ss3(    ss3_tmp),
  .mosi(  mosi),
  .miso(  miso),
  .dev_sel(dev_sel),
  .start(start),
  .busy(busy),
  .clk_end(clk_end),
  .wr_data(wr_data),
  .rd_data(rd_data),
  .rd_data_en(rd_data_en));
   
//SSM̋ɐύX
//foCXɂSSM̋ɐႤ́AgpfoCX̋ɐɍ킹ĂB
//st93c86 1ŗL
assign ss0 = ss0_tmp;
//mcp4922 0ŗL
assign ss1 = ~ss1_tmp;
//mcp3002 0ŗL
assign ss2 = ~ss2_tmp;
//
assign ss3 = ss3_tmp;


//Rg[W[̑I
//sRp`ɂȂĂ̂ŃCX^X郂W[ύX邱ƂŁAW[Ił܂B
//gp郂W[ȊO̓RgAEgĂB

//AT93C86(EEPROM)p̃Rg[W[
//spi_at93c86 spi_device (
//MPC4922(DAϊ)p̃Rg[W[
//spi_mcp4922 spi_device (
//MPC3002(ADϊ)p̃Rg[W[
//spi_mcp3002 spi_device (
//MCP4922,MPC3002gp̃Rg[W[
spi_mcp3002_4922 spi_device (
  .clk(clk), 
  .rstb(rstb), 
  .led_0( led_0),
  .dev_sel(dev_sel),
  .start(start),
  .clk_end(clk_end),
  .wr_data(wr_data),
  .rd_data(rd_data),
  .rd_data_en(rd_data_en),
  .tx_fifo_data_en(tx_fifo_data_en),   
  .tx_fifo_data   (tx_fifo_data));

//fifõp[^w     
parameter data_width = 8   ;
parameter data_no = data_width -1;
parameter adr_width = 4   ;
parameter adr_no = adr_width -1;
parameter mem_size = (1 << adr_width)-1;

assign tx_fifo_ren = ((tx_busy==1'b0)&&(tx_data_en==1'b0))?1'b1:1'b0;

fifo
#(data_width,
  data_no,
  adr_width,
  adr_no,
  mem_size)
tx_fifo(
.CLK    (clk),
.RESET_N  (rstb), 
.WEN    (tx_fifo_data_en),   
.WDAT   (tx_fifo_data),  
.REN    (tx_fifo_ren),     
.RDAT   (tx_data),
.RDAT_EN(tx_data_en),
.EMPTY  (tx_fifo_empty),
.FULL   (tx_fifo_full),
.N_FULL (tx_fifo_n_full)
);

assign rx_fifo_ren = 1'b1;
        
rs232c_tx_rx  rs232c_tx_rx(
.RESETB(     rstb),      
.CLK(        clk),           
.TXD(        txd),           
.RXD(        rxd),           
.TX_DATA(    tx_data ),     
.TX_DATA_EN( tx_data_en),  
.TX_BUSY(    tx_busy),     
.RX_DATA(    rx_data),     
.RX_DATA_EN( rx_data_en),  
.RX_BUSY(    rx_busy))             
;
  

endmodule